Index: /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/HeuristicLab.Encodings.Permutation-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/HeuristicLab.Encodings.Permutation-3.3.csproj	(revision 2983)
+++ /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/HeuristicLab.Encodings.Permutation-3.3.csproj	(revision 2984)
@@ -104,4 +104,7 @@
     <Compile Include="Manipulators\TranslocationInversionManipulator.cs" />
     <Compile Include="Manipulators\TranslocationManipulator.cs" />
+    <Compile Include="Moves\Permutation2IndexMove.cs" />
+    <Compile Include="Moves\Permutation2OptExhaustiveMoveGenerator.cs" />
+    <Compile Include="Moves\Permutation2OptMove.cs" />
     <Compile Include="PermutationManipulator.cs" />
     <Compile Include="PermutationCrossover.cs" />
Index: /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Moves/Permutation2IndexMove.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Moves/Permutation2IndexMove.cs	(revision 2984)
+++ /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Moves/Permutation2IndexMove.cs	(revision 2984)
@@ -0,0 +1,48 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.Permutation {
+  [Item("Permutation2IndexMove", "A move on a permutation that is specified by 2 indices")]
+  public class Permutation2IndexMove : Item {
+    [Storable]
+    public int Index1 { get; protected set; }
+    [Storable]
+    public int Index2 { get; protected set; }
+    [Storable]
+    public Permutation Permutation { get; protected set; }
+
+    protected Permutation2IndexMove() {
+      Index1 = -1;
+      Index2 = -1;
+      Permutation = null;
+    }
+
+    public Permutation2IndexMove(int index1, int index2, Permutation permutation)
+      : base() {
+      Index1 = index1;
+      Index2 = index2;
+      Permutation = permutation;
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Moves/Permutation2OptExhaustiveMoveGenerator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Moves/Permutation2OptExhaustiveMoveGenerator.cs	(revision 2984)
+++ /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Moves/Permutation2OptExhaustiveMoveGenerator.cs	(revision 2984)
@@ -0,0 +1,32 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Operators;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.Permutation.Moves {
+  public class Permutation2OptExhaustiveMoveGenerator : SingleSuccessorOperator {
+    public override IOperation Apply() {
+      return base.Apply();
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Moves/Permutation2OptMove.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Moves/Permutation2OptMove.cs	(revision 2984)
+++ /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Moves/Permutation2OptMove.cs	(revision 2984)
@@ -0,0 +1,40 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.Permutation {
+  [Item("Permutation2OptMove", "Item that describes a 2-Opt move.")]
+  public class Permutation2OptMove : Permutation2IndexMove {
+    protected Permutation2OptMove()
+      : base() {
+    }
+
+    public Permutation2OptMove(int index1, int index2)
+      : base(index1, index2, null) {
+    }
+
+    public Permutation2OptMove(int index1, int index2, Permutation permutation)
+      : base(index1, index2, permutation) {
+    }
+  }
+}