Index: /trunk/sources/HeuristicLab.Analysis/3.3/DataRow.cs
===================================================================
--- /trunk/sources/HeuristicLab.Analysis/3.3/DataRow.cs	(revision 2994)
+++ /trunk/sources/HeuristicLab.Analysis/3.3/DataRow.cs	(revision 2995)
@@ -30,4 +30,5 @@
   [Item("DataRow", "A row of data values.")]
   [Creatable("Test")]
+  [StorableClass(StorableClassType.MarkedOnly)]
   public sealed class DataRow : NamedItem {
     [Storable]
Index: /trunk/sources/HeuristicLab.Analysis/3.3/DataTable.cs
===================================================================
--- /trunk/sources/HeuristicLab.Analysis/3.3/DataTable.cs	(revision 2994)
+++ /trunk/sources/HeuristicLab.Analysis/3.3/DataTable.cs	(revision 2995)
@@ -29,4 +29,5 @@
   [Item("DataTable", "A table of data values.")]
   [Creatable("Test")]
+  [StorableClass(StorableClassType.MarkedOnly)]
   public sealed class DataTable : NamedItem {
     [Storable]
Index: /trunk/sources/HeuristicLab.Collections/3.3/ObservableKeyedCollection.cs
===================================================================
--- /trunk/sources/HeuristicLab.Collections/3.3/ObservableKeyedCollection.cs	(revision 2994)
+++ /trunk/sources/HeuristicLab.Collections/3.3/ObservableKeyedCollection.cs	(revision 2995)
@@ -29,4 +29,5 @@
 namespace HeuristicLab.Collections {
   [Serializable]
+  [StorableClass(StorableClassType.MarkedOnly)]
   public abstract class ObservableKeyedCollection<TKey, TItem> : IObservableKeyedCollection<TKey, TItem> {
     [Storable]
Index: /trunk/sources/HeuristicLab.Core/3.3/Engine.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Engine.cs	(revision 2994)
+++ /trunk/sources/HeuristicLab.Core/3.3/Engine.cs	(revision 2995)
@@ -34,4 +34,5 @@
   /// </summary>
   [Item("Engine", "A base class for engines.")]
+  [StorableClass(StorableClassType.MarkedOnly)]
   public abstract class Engine : Item, IEngine {
     public override Image ItemImage {
Index: /trunk/sources/HeuristicLab.Core/3.3/NamedItem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/NamedItem.cs	(revision 2994)
+++ /trunk/sources/HeuristicLab.Core/3.3/NamedItem.cs	(revision 2995)
@@ -26,4 +26,5 @@
 namespace HeuristicLab.Core {
   [Item("NamedItem", "Base class for items which have a name and an optional description.")]
+  [StorableClass(StorableClassType.MarkedOnly)]
   public abstract class NamedItem : Item, INamedItem {
     [Storable]
Index: /trunk/sources/HeuristicLab.Core/3.3/ParameterizedNamedItem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/ParameterizedNamedItem.cs	(revision 2994)
+++ /trunk/sources/HeuristicLab.Core/3.3/ParameterizedNamedItem.cs	(revision 2995)
@@ -28,4 +28,5 @@
   /// </summary>
   [Item("ParameterizedNamedItem", "A base class for items which have a name and contain parameters.")]
+  [StorableClass(StorableClassType.MarkedOnly)]
   public abstract class ParameterizedNamedItem : NamedItem, IParameterizedNamedItem {
     private ParameterCollection parameters;
Index: /trunk/sources/HeuristicLab.Core/3.3/Scope.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Scope.cs	(revision 2994)
+++ /trunk/sources/HeuristicLab.Core/3.3/Scope.cs	(revision 2995)
@@ -29,4 +29,5 @@
   [Item("Scope", "A scope which contains variables and sub-scopes.")]
   [Creatable("Test")]
+  [StorableClass(StorableClassType.MarkedOnly)]
   public sealed class Scope : NamedItem, IScope {
     [Storable]
Index: /trunk/sources/HeuristicLab.Core/3.3/Variable.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Variable.cs	(revision 2994)
+++ /trunk/sources/HeuristicLab.Core/3.3/Variable.cs	(revision 2995)
@@ -30,4 +30,5 @@
   [Item("Variable", "A variable which has a name and holds an IItem.")]
   [Creatable("Test")]
+  [StorableClass(StorableClassType.MarkedOnly)]
   public sealed class Variable : NamedItem, IVariable {
     private IItem value;
Index: /trunk/sources/HeuristicLab.Data/3.3/StringArrayData.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/StringArrayData.cs	(revision 2994)
+++ /trunk/sources/HeuristicLab.Data/3.3/StringArrayData.cs	(revision 2995)
@@ -30,4 +30,5 @@
   [Item("StringArrayData", "Represents an array of strings.")]
   [Creatable("Test")]
+  [StorableClass(StorableClassType.MarkedOnly)]
   public sealed class StringArrayData : Item, IEnumerable, IStringConvertibleArrayData {
     [Storable]
Index: /trunk/sources/HeuristicLab.Data/3.3/StringData.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/StringData.cs	(revision 2994)
+++ /trunk/sources/HeuristicLab.Data/3.3/StringData.cs	(revision 2995)
@@ -25,7 +25,7 @@
 
 namespace HeuristicLab.Data {
-  [StorableClass(StorableClassType.MarkedOnly)]
   [Item("StringData", "Represents a string.")]
   [Creatable("Test")]
+  [StorableClass(StorableClassType.MarkedOnly)]
   public sealed class StringData : Item, IComparable, IStringConvertibleData {
     [Storable]
Index: /trunk/sources/HeuristicLab.Data/3.3/StringMatrixData.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/StringMatrixData.cs	(revision 2994)
+++ /trunk/sources/HeuristicLab.Data/3.3/StringMatrixData.cs	(revision 2995)
@@ -30,4 +30,5 @@
   [Item("StringMatrixData", "Represents a matrix of strings.")]
   [Creatable("Test")]
+  [StorableClass(StorableClassType.MarkedOnly)]
   public sealed class StringMatrixData : Item, IEnumerable, IStringConvertibleMatrixData {
     [Storable]
Index: /trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/Model/GraphVisualizationInfo.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/Model/GraphVisualizationInfo.cs	(revision 2994)
+++ /trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/Model/GraphVisualizationInfo.cs	(revision 2995)
@@ -31,4 +31,5 @@
 
 namespace HeuristicLab.Operators.Views.GraphVisualization {
+  [StorableClass(StorableClassType.MarkedOnly)]
   public sealed class GraphVisualizationInfo : DeepCloneable {
     private BidirectionalLookup<IOperator, IOperatorShapeInfo> operatorShapeInfoMapping;
Index: /trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/Model/OperatorShapeInfo.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/Model/OperatorShapeInfo.cs	(revision 2994)
+++ /trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/Model/OperatorShapeInfo.cs	(revision 2995)
@@ -31,4 +31,5 @@
 
 namespace HeuristicLab.Operators.Views.GraphVisualization {
+  [StorableClass(StorableClassType.MarkedOnly)]
   internal class OperatorShapeInfo : ShapeInfo, IOperatorShapeInfo {
     [Storable]
Index: /trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/Model/ShapeInfo.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/Model/ShapeInfo.cs	(revision 2994)
+++ /trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/Model/ShapeInfo.cs	(revision 2995)
@@ -31,4 +31,5 @@
 
 namespace HeuristicLab.Operators.Views.GraphVisualization {
+  [StorableClass(StorableClassType.MarkedOnly)]
   internal abstract class ShapeInfo : DeepCloneable, IShapeInfo {
     private ShapeInfo() {
Index: /trunk/sources/HeuristicLab.Operators/3.3/AlgorithmOperator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators/3.3/AlgorithmOperator.cs	(revision 2994)
+++ /trunk/sources/HeuristicLab.Operators/3.3/AlgorithmOperator.cs	(revision 2995)
@@ -29,4 +29,5 @@
   /// </summary>
   [Item("AlgorithmOperator", "An operator which represents an algorithm represented as an operator graph.")]
+  [StorableClass(StorableClassType.MarkedOnly)]
   public abstract class AlgorithmOperator : SingleSuccessorOperator {
     public override Image ItemImage {
Index: /trunk/sources/HeuristicLab.Operators/3.3/MultipleCallsOperator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators/3.3/MultipleCallsOperator.cs	(revision 2994)
+++ /trunk/sources/HeuristicLab.Operators/3.3/MultipleCallsOperator.cs	(revision 2995)
@@ -32,4 +32,5 @@
   /// </summary>
   [Item("MultipleCallsOperator", "A base class for operators which apply multiple user-defined operators.")]
+  [StorableClass(StorableClassType.MarkedOnly)]
   public abstract class MultipleCallsOperator : SingleSuccessorOperator {
     protected IValueParameter<IOperator>[] OperatorParameters {
Index: /trunk/sources/HeuristicLab.Operators/3.3/Operator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators/3.3/Operator.cs	(revision 2994)
+++ /trunk/sources/HeuristicLab.Operators/3.3/Operator.cs	(revision 2995)
@@ -30,4 +30,5 @@
   /// </summary>
   [Item("Operator", "Base class for operators.")]
+  [StorableClass(StorableClassType.MarkedOnly)]
   public abstract class Operator : ParameterizedNamedItem, IOperator {
     public override Image ItemImage {
Index: /trunk/sources/HeuristicLab.Operators/3.3/ValuesCollector.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators/3.3/ValuesCollector.cs	(revision 2994)
+++ /trunk/sources/HeuristicLab.Operators/3.3/ValuesCollector.cs	(revision 2995)
@@ -30,4 +30,5 @@
   [Item("ValuesCollector", "An operator which collects the actual values of parameters.")]
   [Creatable("Test")]
+  [StorableClass(StorableClassType.MarkedOnly)]
   public abstract class ValuesCollector : SingleSuccessorOperator, IOperator {
     private ParameterCollection collectedValues;
Index: /trunk/sources/HeuristicLab.Optimization/3.3/Algorithm.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization/3.3/Algorithm.cs	(revision 2994)
+++ /trunk/sources/HeuristicLab.Optimization/3.3/Algorithm.cs	(revision 2995)
@@ -32,4 +32,5 @@
   /// </summary>
   [Item("Algorithm", "A base class for algorithms.")]
+  [StorableClass(StorableClassType.MarkedOnly)]
   public abstract class Algorithm : ParameterizedNamedItem, IAlgorithm {
     public override Image ItemImage {
Index: /trunk/sources/HeuristicLab.Optimization/3.3/EngineAlgorithm.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization/3.3/EngineAlgorithm.cs	(revision 2994)
+++ /trunk/sources/HeuristicLab.Optimization/3.3/EngineAlgorithm.cs	(revision 2995)
@@ -33,4 +33,5 @@
   /// </summary>
   [Item("EngineAlgorithm", "A base class for algorithms which use an engine for execution.")]
+  [StorableClass(StorableClassType.MarkedOnly)]
   public abstract class EngineAlgorithm : Algorithm {
     private OperatorGraph operatorGraph;
Index: /trunk/sources/HeuristicLab.Parameters/3.3/Parameter.cs
===================================================================
--- /trunk/sources/HeuristicLab.Parameters/3.3/Parameter.cs	(revision 2994)
+++ /trunk/sources/HeuristicLab.Parameters/3.3/Parameter.cs	(revision 2995)
@@ -30,4 +30,5 @@
   /// </summary>
   [Item("Parameter", "A base class for parameters.")]
+  [StorableClass(StorableClassType.MarkedOnly)]
   public abstract class Parameter : NamedItem, IParameter {
     public override bool CanChangeName {