Index: /trunk/sources/HeuristicLab.Data/3.3/BoolArrayData.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/BoolArrayData.cs	(revision 2995)
+++ /trunk/sources/HeuristicLab.Data/3.3/BoolArrayData.cs	(revision 2996)
@@ -25,7 +25,7 @@
 
 namespace HeuristicLab.Data {
-  [StorableClass(StorableClassType.Empty)]
   [Item("BoolArrayData", "Represents an array of boolean values.")]
   [Creatable("Test")]
+  [StorableClass(StorableClassType.Empty)]
   public sealed class BoolArrayData : ValueTypeArrayData<bool>, IStringConvertibleArrayData {
     public BoolArrayData() : base() { }
Index: /trunk/sources/HeuristicLab.Data/3.3/BoolData.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/BoolData.cs	(revision 2995)
+++ /trunk/sources/HeuristicLab.Data/3.3/BoolData.cs	(revision 2996)
@@ -26,7 +26,7 @@
 
 namespace HeuristicLab.Data {
-  [StorableClass(StorableClassType.Empty)]
   [Item("BoolData", "Represents a boolean value.")]
   [Creatable("Test")]
+  [StorableClass(StorableClassType.Empty)]
   public sealed class BoolData : ValueTypeData<bool>, IComparable, IStringConvertibleData {
     public BoolData() : base() { }
Index: /trunk/sources/HeuristicLab.Data/3.3/BoolMatrixData.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/BoolMatrixData.cs	(revision 2995)
+++ /trunk/sources/HeuristicLab.Data/3.3/BoolMatrixData.cs	(revision 2996)
@@ -25,7 +25,7 @@
 
 namespace HeuristicLab.Data {
-  [StorableClass(StorableClassType.Empty)]
   [Item("BoolMatrixData", "Represents a matrix of boolean values.")]
   [Creatable("Test")]
+  [StorableClass(StorableClassType.Empty)]
   public sealed class BoolMatrixData : ValueTypeMatrixData<bool>, IStringConvertibleMatrixData {
     public BoolMatrixData() : base() { }
Index: /trunk/sources/HeuristicLab.Data/3.3/ComparisonData.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/ComparisonData.cs	(revision 2995)
+++ /trunk/sources/HeuristicLab.Data/3.3/ComparisonData.cs	(revision 2996)
@@ -25,7 +25,7 @@
 
 namespace HeuristicLab.Data {
-  [StorableClass(StorableClassType.Empty)]
   [Item("ComparisonData", "Represents a comparison.")]
   [Creatable("Test")]
+  [StorableClass(StorableClassType.Empty)]
   public sealed class ComparisonData : ValueTypeData<Comparison>, IComparable {
     public ComparisonData() : base() { }
Index: /trunk/sources/HeuristicLab.Data/3.3/DateTimeData.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/DateTimeData.cs	(revision 2995)
+++ /trunk/sources/HeuristicLab.Data/3.3/DateTimeData.cs	(revision 2996)
@@ -25,7 +25,7 @@
 
 namespace HeuristicLab.Data {
-  [StorableClass(StorableClassType.Empty)]
   [Item("DateTimeData", "Represents a date and time value.")]
   [Creatable("Test")]
+  [StorableClass(StorableClassType.Empty)]
   public sealed class DateTimeData : ValueTypeData<DateTime>, IComparable, IStringConvertibleData {
     public DateTimeData() : base() { }
Index: /trunk/sources/HeuristicLab.Data/3.3/DoubleArrayData.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/DoubleArrayData.cs	(revision 2995)
+++ /trunk/sources/HeuristicLab.Data/3.3/DoubleArrayData.cs	(revision 2996)
@@ -25,7 +25,7 @@
 
 namespace HeuristicLab.Data {
-  [StorableClass(StorableClassType.Empty)]
   [Item("DoubleArrayData", "Represents an array of double values.")]
   [Creatable("Test")]
+  [StorableClass(StorableClassType.Empty)]
   public sealed class DoubleArrayData : ValueTypeArrayData<double>, IStringConvertibleArrayData {
     public DoubleArrayData() : base() { }
Index: /trunk/sources/HeuristicLab.Data/3.3/DoubleData.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/DoubleData.cs	(revision 2995)
+++ /trunk/sources/HeuristicLab.Data/3.3/DoubleData.cs	(revision 2996)
@@ -26,7 +26,7 @@
 
 namespace HeuristicLab.Data {
-  [StorableClass(StorableClassType.Empty)]
   [Item("DoubleData", "Represents a double value.")]
   [Creatable("Test")]
+  [StorableClass(StorableClassType.Empty)]
   public sealed class DoubleData : ValueTypeData<double>, IComparable, IStringConvertibleData {
     public DoubleData() : base() { }
Index: /trunk/sources/HeuristicLab.Data/3.3/DoubleMatrixData.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/DoubleMatrixData.cs	(revision 2995)
+++ /trunk/sources/HeuristicLab.Data/3.3/DoubleMatrixData.cs	(revision 2996)
@@ -25,7 +25,7 @@
 
 namespace HeuristicLab.Data {
-  [StorableClass(StorableClassType.Empty)]
   [Item("DoubleMatrixData", "Represents a matrix of double values.")]
   [Creatable("Test")]
+  [StorableClass(StorableClassType.Empty)]
   public sealed class DoubleMatrixData : ValueTypeMatrixData<double>, IStringConvertibleMatrixData {
     public DoubleMatrixData() : base() { }
Index: /trunk/sources/HeuristicLab.Data/3.3/IntArrayData.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/IntArrayData.cs	(revision 2995)
+++ /trunk/sources/HeuristicLab.Data/3.3/IntArrayData.cs	(revision 2996)
@@ -25,7 +25,7 @@
 
 namespace HeuristicLab.Data {
-  [StorableClass(StorableClassType.Empty)]
   [Item("IntArrayData", "Represents an array of integer values.")]
   [Creatable("Test")]
+  [StorableClass(StorableClassType.Empty)]
   public sealed class IntArrayData : ValueTypeArrayData<int>, IStringConvertibleArrayData {
     public IntArrayData() : base() { }
Index: /trunk/sources/HeuristicLab.Data/3.3/IntData.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/IntData.cs	(revision 2995)
+++ /trunk/sources/HeuristicLab.Data/3.3/IntData.cs	(revision 2996)
@@ -26,7 +26,7 @@
 
 namespace HeuristicLab.Data {
-  [StorableClass(StorableClassType.Empty)]
   [Item("IntData", "Represents an integer value.")]
   [Creatable("Test")]
+  [StorableClass(StorableClassType.Empty)]
   public sealed class IntData : ValueTypeData<int>, IComparable, IStringConvertibleData {
     public IntData() : base() { }
Index: /trunk/sources/HeuristicLab.Data/3.3/IntMatrixData.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/IntMatrixData.cs	(revision 2995)
+++ /trunk/sources/HeuristicLab.Data/3.3/IntMatrixData.cs	(revision 2996)
@@ -25,7 +25,7 @@
 
 namespace HeuristicLab.Data {
-  [StorableClass(StorableClassType.Empty)]
   [Item("IntMatrixData", "Represents a matrix of integer values.")]
   [Creatable("Test")]
+  [StorableClass(StorableClassType.Empty)]
   public sealed class IntMatrixData : ValueTypeMatrixData<int>, IStringConvertibleMatrixData {
     public IntMatrixData() : base() { }
Index: /trunk/sources/HeuristicLab.Data/3.3/TimeSpanData.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/TimeSpanData.cs	(revision 2995)
+++ /trunk/sources/HeuristicLab.Data/3.3/TimeSpanData.cs	(revision 2996)
@@ -26,7 +26,7 @@
 
 namespace HeuristicLab.Data {
-  [StorableClass(StorableClassType.Empty)]
   [Item("TimeSpanData", "Represents a duration of time.")]
   [Creatable("Test")]
+  [StorableClass(StorableClassType.Empty)]
   public sealed class TimeSpanData : ValueTypeData<TimeSpan>, IComparable, IStringConvertibleData {
     public TimeSpanData() : base() { }
Index: /trunk/sources/HeuristicLab.Encodings.RealVector/3.3/Crossovers/UniformSomePositionsArithmeticCrossover.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.RealVector/3.3/Crossovers/UniformSomePositionsArithmeticCrossover.cs	(revision 2995)
+++ /trunk/sources/HeuristicLab.Encodings.RealVector/3.3/Crossovers/UniformSomePositionsArithmeticCrossover.cs	(revision 2996)
@@ -35,5 +35,6 @@
   /// </remarks>
   [Item("UniformSomePositionsArithmeticCrossover", "The uniform some positions arithmetic crossover (continuous recombination) constructs an offspring by calculating x = alpha * p1 + (1-alpha) * p2 for a position x in the vector with a given probability (otherwise p1 is taken at this position). It is implemented as described in Dumitrescu, D. et al. (2000), Evolutionary computation, CRC Press, Boca Raton, FL, p. 191. Note that Dumitrescu et al. specify the alpha to be 0.5.")]
-  class UniformSomePositionsArithmeticCrossover : RealVectorCrossover {
+  [StorableClass(StorableClassType.Empty)]
+  public class UniformSomePositionsArithmeticCrossover : RealVectorCrossover {
     /// <summary>
     /// The alpha parameter needs to be in the interval [0;1] and specifies how close the resulting offspring should be either to parent1 (alpha -> 0) or parent2 (alpha -> 1).
Index: /trunk/sources/HeuristicLab.Encodings.RealVector/3.3/Manipulators/BreederGeneticAlgorithmManipulator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.RealVector/3.3/Manipulators/BreederGeneticAlgorithmManipulator.cs	(revision 2995)
+++ /trunk/sources/HeuristicLab.Encodings.RealVector/3.3/Manipulators/BreederGeneticAlgorithmManipulator.cs	(revision 2996)
@@ -35,4 +35,5 @@
   /// </remarks>
   [Item("BreederGeneticAlgorithmManipulator", "It is implemented as described by Mühlenbein, H. and Schlierkamp-Voosen, D. 1993. Predictive Models for the Breeder Genetic Algorithm - I. Continuous Parameter Optimization. Evolutionary Computation, 1(1), pp. 25-49.")]
+  [StorableClass(StorableClassType.Empty)]
   public class BreederGeneticAlgorithmManipulator : RealVectorManipulator {
     private static readonly double[] powerOfTwo = new double[] { 1, 0.5, 0.25, 0.125, 0.0625, 0.03125, 0.015625, 0.0078125, 0.00390625, 0.001953125, 0.0009765625, 0.00048828125, 0.000244140625, 0.0001220703125, 0.00006103515625, 0.000030517578125 };
Index: /trunk/sources/HeuristicLab.Parameters/3.3/SubScopesLookupParameter.cs
===================================================================
--- /trunk/sources/HeuristicLab.Parameters/3.3/SubScopesLookupParameter.cs	(revision 2995)
+++ /trunk/sources/HeuristicLab.Parameters/3.3/SubScopesLookupParameter.cs	(revision 2996)
@@ -23,4 +23,5 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
 namespace HeuristicLab.Parameters {
@@ -29,4 +30,5 @@
   /// </summary>
   [Item("SubScopesLookupParameter<T>", "A generic parameter representing instances of type T which are collected from or written to the sub-scopes of the current scope.")]
+  [StorableClass(StorableClassType.Empty)]
   public class SubScopesLookupParameter<T> : LookupParameter<ItemArray<T>> where T : class, IItem {
     public SubScopesLookupParameter() : base() { }